#ifndef _PACKAGE_H
#define _PACKAGE_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define BufferSize  (512 * 1024)
#define ExtraSize   (256 * 1024)
#define HARDCHECKSUM 9841478
#define HASHKEYLEN   512
#define CHECKSUMLEN  1024
#define CRYPTMETHOD  SWAPMATRIX

#define OPTION_COMPRESSION 1
#define OPTION_ENCRYPTION  2
#define OPTION_DATETIME    3
#define OPTION_CRCCHECK    4
#define OPTION_SAVEPATHS   5

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool BreakPackage(char *SrcName, char *TarFolder, char *RawKey, int RawKeyLen);
bool MakePackage(char *SrcFolder, char *TarName, char *RawKey, int RawKeyLen);
bool PopGrid(char *SrcName, char *RawKey, int RawKeyLen);
bool TestPackage(void);
DWORD WINAPI CreateFileArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI CreateNewDirArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI ViewExisting_Worker_Thread(LPVOID xData);
DWORD WINAPI ExtractEntireArchive_Worker_Thread(LPVOID xData);
long MakeChecksum(char *RawKey);
void CreateFolderStructure(char *FullFileName);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern DWORD PackageProgress;

extern DWORD Worker_Thread_ID;
extern  HANDLE Worker_Thread_Handle;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
